﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MvcSampleApplication.Models;
using MVCSampleBrowser.Models;
using System.Collections;
using Syncfusion.Mvc.Grid;

namespace exceledit_rzor_mvc.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            IEnumerable data = OrderRepository.GetAllRecords();
            return View(data);
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index( PagingParams args)
        {
            IEnumerable data = OrderRepository.GetAllRecords();
            return data.GridJSONActions<EditableOrder>();
        }

        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult BulkSave([Bind(Prefix = "updatedRecords")]IEnumerable<EditableOrder> orders, [Bind(Prefix = "addedRecords")]IEnumerable<EditableOrder> addRcrds, [Bind(Prefix = "deletedRecords")]IEnumerable<EditableOrder> delRcrds)
        {
            //Repository action method Update used for perform update the records into datasource
            if (orders != null)
                OrderRepository.Update(orders);
            if (addRcrds != null)
                OrderRepository.Add(addRcrds);
            if (delRcrds != null)
                OrderRepository.Delete(delRcrds);
            //After save the records into datasource refresh the grid
            var data = OrderRepository.GetAllRecords();
            return data.GridJSONActions<EditableOrder>();
        }

        public ActionResult About()
        {
            return View();
        }
    }
}
