﻿#region Copyright Syncfusion Inc. 2001 - 2011
// Copyright Syncfusion Inc. 2001 - 2011. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
namespace MVCSampleBrowser.Models
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Web;
    using MVCSampleBrowser.Models;
    using MvcSampleApplication.Models;
   
    using _84719_excel.Models;


    public static class OrderRepository
    {
        public static IList<EditableOrder> GetAllRecords()
        {
            IList<EditableOrder> orders = (IList<EditableOrder>)HttpContext.Current.Session["Orders"];

            if (orders == null)
            {
             HttpContext.Current.Session["Orders"]  = orders = (from ord in new NorthwindDataContext().Orders.Take(10)
                          select new EditableOrder
                          {
                              OrderID = ord.OrderID,
                              CustomerID = ord.CustomerID,
                              EmployeeID = ord.EmployeeID,
                              Freight = ord.Freight,
                          }).ToList();
            }
            return orders;
        }


        public static void Add(EditableOrder order)
        {
            GetAllRecords().Insert(0, order);
        }
        public static void Add(IEnumerable<EditableOrder> orders)
        {
            foreach (var order in orders)
            {
                GetAllRecords().Insert(0, order);
            }
        }
        public static EditableOrder Select(int? OrderID)
        {
            
            EditableOrder result = GetAllRecords().Where(o => o.OrderID == OrderID).FirstOrDefault();
            
            return result;
        }

        public static void Delete(int OrderID)
        {
            EditableOrder result = GetAllRecords().Where(o => o.OrderID == OrderID).FirstOrDefault();
            GetAllRecords().Remove(result);
        }
        public static void Delete(IEnumerable<EditableOrder> orders)
        {
            foreach (var res in orders)
            {
                EditableOrder result = GetAllRecords().Where(o => o.OrderID == res.OrderID).FirstOrDefault();
                GetAllRecords().Remove(result);
            }
        }

        public static void Update(EditableOrder order)
        {
            EditableOrder result = GetAllRecords().Where(o => o.OrderID == order.OrderID).FirstOrDefault();
            if (result != null)
            {
                result.OrderID = order.OrderID;
                result.CustomerID = order.CustomerID;
                result.EmployeeID = order.EmployeeID;
                result.Freight = order.Freight;
            }
        }

        public static void Update(IEnumerable<EditableOrder> orders)
        {
            foreach (var order in orders)
            {
                EditableOrder result = GetAllRecords().Where(o => o.OrderID == order.OrderID).FirstOrDefault();
                if (result != null)
                {
                    result.OrderID = order.OrderID;
                    result.CustomerID = order.CustomerID;
                    result.EmployeeID = order.EmployeeID;
                    result.Freight = order.Freight;
                }
            }
        }
    }
}
