﻿
function Grid1QueryCell(sender, args) {
    if (args.Column.Name) {

        var currentData = "dataSource()[" + args.Element.parentNode.rowIndex + "].";

        // Here we are setting knockout data-binding attribute
        $(args.Element).attr("data-bind",
            "text: " + currentData + args.Column.Name +
            ",css: {updatedCell : " + currentData + "isDirty}");

        // text: is for update cell value and
        // css: is for notifying user that cells has been updated
    }
}

// created custom extender for auto updating JsonData as well as model
ko.extenders.AutoUpdate = function (target, options) {

    target(options.model.data[options.name]);

    target.subscribe(function (newValue) {

        // Notifying model that it has been changed
        if (!options.model.isDirty())
            options.model.isDirty(true);

        // Updating changed values to original JSON data
        options.model.data[options.name] = newValue;
    });

    return target;
}

ko.syncJsMap = function (obj, viewModel) {
    if (obj.length) {
        var mapArray = [];
        for (var i = 0; i < obj.length; i++) {
            mapArray.push(new viewModel(obj[i]));
        }
        return mapArray;
    }
}

function OrderViewModel(data) {

    // Actual JSON from grid
    this.data = data;

    // This is to detect changes in Model
    this.isDirty = ko.observable(false);

    // Model Properties
    this.OrderID = ko.observable().extend({ AutoUpdate: { "model": this, "name": "OrderID" } });
    this.CustomerID = ko.observable().extend({ AutoUpdate: { "model": this, "name": "CustomerID" } });
    this.EmployeeID = ko.observable().extend({ AutoUpdate: { "model": this, "name": "EmployeeID" } });
    this.Freight = ko.observable().extend({ AutoUpdate: { "model": this, "name": "Freight" } });
}

function PageViewModel() {
    this.dataSource = ko.observableArray([]);
}

// jQuery ready event has been used to define page view model
$(function () {
    page = new PageViewModel();

    // Ko Binding can be applied to whole page here.
    // ko.applyBindings(page);
});

// Grid's OnActionComplete event has been used to update the KO's datasource
function ActionComplete(grid, args) {

    // Here we are setting page dataSource
    page.dataSource(ko.syncJsMap(grid.get_jsonModeMgr().get_dataSource(), OrderViewModel));

    // I'm going to enable All toolbar items
    grid.gridtoolbar.Enable_All();

    // clearing previous binding if any
    ko.cleanNode($(grid.get_element()).find(".GridContent").children().get(0));

    // apply bindings to newly created content
    ko.applyBindings(page, $(grid.get_element()).find(".GridContent").children().get(0));
}

// We need set updatedRecords on Toolbar click event
function ToolbarClicked(grid, args) {
    // Getting changed JSON data
    var koChanges = page.dataSource()
        .filter(
        function (obj) { return obj.isDirty(); });

    // Marking grid as Editing
    grid._edit._isEdit = true;

    // Updating the changed records to grid
    if (grid._edit._updatedRecords) {
        // Merging the changes if any updates from grid
        for (var i = 0; i < koChanges.length; i++) {
            if (grid._edit._updatedRecords.indexOf(koChanges[i].data) == -1)
                grid._edit._updatedRecords.push(koChanges[i].data);
        }
    }
    else {
        grid._edit._updatedRecords = ko.utils.arrayMap(koChanges, function (obj) { return obj.data; });
    }
}
